Difference between revisions of "Code snippets"

From FreeCAD Documentation
Jump to: navigation, search
(Marked this version for translation)
({{Code|code= }} and supp spaces)
Line 7: Line 7:
 
Every module must contain, besides your main module file, an InitGui.py file, responsible for inserting the module in the main Gui. This is an example of a simple one.  
 
Every module must contain, besides your main module file, an InitGui.py file, responsible for inserting the module in the main Gui. This is an example of a simple one.  
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
class ScriptWorkbench (Workbench):  
+
class ScriptWorkbench (Workbench):  
    MenuText = "Scripts"
+
    MenuText = "Scripts"
    def Initialize(self):
+
    def Initialize(self):
        import Scripts # assuming Scripts.py is your module
+
        import Scripts # assuming Scripts.py is your module
        list = ["Script_Cmd"] # That list must contain command names, that can be defined in Scripts.py
+
        list = ["Script_Cmd"] # That list must contain command names, that can be defined in Scripts.py
        self.appendToolbar("My Scripts",list)  
+
        self.appendToolbar("My Scripts",list)  
       
+
       
Gui.addWorkbench(ScriptWorkbench())
+
Gui.addWorkbench(ScriptWorkbench())
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 22: Line 22:
 
This is an example of a main module file, containing everything your module does. It is the Scripts.py file invoked by the previous example. You can have all your custom commands here.
 
This is an example of a main module file, containing everything your module does. It is the Scripts.py file invoked by the previous example. You can have all your custom commands here.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
  import FreeCAD, FreeCADGui  
 
  import FreeCAD, FreeCADGui  
 
   
 
   
class ScriptCmd:  
+
class ScriptCmd:  
    def Activated(self):  
+
  def Activated(self):  
        # Here your write what your ScriptCmd does...
+
      # Here your write what your ScriptCmd does...
        FreeCAD.Console.PrintMessage('Hello, World!')
+
      FreeCAD.Console.PrintMessage('Hello, World!')
    def GetResources(self):  
+
  def GetResources(self):  
        return {'Pixmap' : 'path_to_an_icon/myicon.png', 'MenuText': 'Short text', 'ToolTip': 'More detailed text'}  
+
      return {'Pixmap' : 'path_to_an_icon/myicon.png', 'MenuText': 'Short text', 'ToolTip': 'More detailed text'}  
 
        
 
        
FreeCADGui.addCommand('Script_Cmd', ScriptCmd())
+
FreeCADGui.addCommand('Script_Cmd', ScriptCmd())
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 42: Line 42:
 
This line must be added to the InitGui.py file to add the new file extension to the list:
 
This line must be added to the InitGui.py file to add the new file extension to the list:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
+
# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")  
+
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")  
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:6-->
 
<!--T:6-->
 
Then in the Import_Ext.py file:
 
Then in the Import_Ext.py file:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
def open(filename):  
+
def open(filename):  
    doc=App.newDocument()
+
  doc=App.newDocument()
    # here you do all what is needed with filename, read, classify data, create corresponding FreeCAD objects
+
  # here you do all what is needed with filename, read, classify data, create corresponding FreeCAD objects
    doc.recompute()
+
  doc.recompute()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:7-->
 
<!--T:7-->
Line 64: Line 64:
 
A line simply has 2 points.
 
A line simply has 2 points.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
  
import Part,PartGui  
+
import Part,PartGui  
doc=App.activeDocument()  
+
doc=App.activeDocument()  
# add a line element to the document and set its points  
+
# add a line element to the document and set its points  
l=Part.Line()
+
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
+
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
+
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape()  
+
doc.addObject("Part::Feature","Line").Shape=l.toShape()  
doc.recompute()
+
doc.recompute()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 80: Line 80:
 
A polygon is simply a set of connected line segments (a polyline in AutoCAD). It doesn't need to be closed.
 
A polygon is simply a set of connected line segments (a polyline in AutoCAD). It doesn't need to be closed.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
import Part,PartGui  
+
import Part,PartGui  
doc=App.activeDocument()
+
doc=App.activeDocument()
n=list()  
+
n=list()  
# create a 3D vector, set its coordinates and add it to the list  
+
# create a 3D vector, set its coordinates and add it to the list  
v=App.Vector(0,0,0)  
+
v=App.Vector(0,0,0)  
n.append(v)  
+
n.append(v)  
v=App.Vector(10,0,0)  
+
v=App.Vector(10,0,0)  
n.append(v)  
+
n.append(v)  
#... repeat for all nodes  
+
#... repeat for all nodes  
# Create a polygon object and set its nodes  
+
# Create a polygon object and set its nodes  
p=doc.addObject("Part::Polygon","Polygon")  
+
p=doc.addObject("Part::Polygon","Polygon")  
p.Nodes=n  
+
p.Nodes=n  
doc.recompute()
+
doc.recompute()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
=== Adding and removing an object to a group === <!--T:10-->
 
=== Adding and removing an object to a group === <!--T:10-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
doc=App.activeDocument()  
+
doc=App.activeDocument()  
grp=doc.addObject("App::DocumentObjectGroup", "Group")  
+
grp=doc.addObject("App::DocumentObjectGroup", "Group")  
lin=doc.addObject("Part::Feature", "Line")
+
lin=doc.addObject("Part::Feature", "Line")
grp.addObject(lin) # adds the lin object to the group grp
+
grp.addObject(lin) # adds the lin object to the group grp
grp.removeObject(lin) # removes the lin object from the group grp
+
grp.removeObject(lin) # removes the lin object from the group grp
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:11-->
 
<!--T:11-->
Line 112: Line 112:
 
=== Adding a Mesh === <!--T:12-->
 
=== Adding a Mesh === <!--T:12-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
import Mesh
+
import Mesh
doc=App.activeDocument()
+
doc=App.activeDocument()
# create a new empty mesh
+
# create a new empty mesh
m = Mesh.Mesh()
+
m = Mesh.Mesh()
# build up box out of 12 facets
+
# build up box out of 12 facets
m.addFacet(0.0,0.0,0.0, 0.0,0.0,1.0, 0.0,1.0,1.0)
+
m.addFacet(0.0,0.0,0.0, 0.0,0.0,1.0, 0.0,1.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,1.0, 0.0,1.0,0.0)
+
m.addFacet(0.0,0.0,0.0, 0.0,1.0,1.0, 0.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,0.0, 1.0,0.0,1.0)
+
m.addFacet(0.0,0.0,0.0, 1.0,0.0,0.0, 1.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,1.0, 0.0,0.0,1.0)
+
m.addFacet(0.0,0.0,0.0, 1.0,0.0,1.0, 0.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,0.0, 1.0,1.0,0.0)
+
m.addFacet(0.0,0.0,0.0, 0.0,1.0,0.0, 1.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,1.0,0.0, 1.0,0.0,0.0)
+
m.addFacet(0.0,0.0,0.0, 1.0,1.0,0.0, 1.0,0.0,0.0)
m.addFacet(0.0,1.0,0.0, 0.0,1.0,1.0, 1.0,1.0,1.0)
+
m.addFacet(0.0,1.0,0.0, 0.0,1.0,1.0, 1.0,1.0,1.0)
m.addFacet(0.0,1.0,0.0, 1.0,1.0,1.0, 1.0,1.0,0.0)
+
m.addFacet(0.0,1.0,0.0, 1.0,1.0,1.0, 1.0,1.0,0.0)
m.addFacet(0.0,1.0,1.0, 0.0,0.0,1.0, 1.0,0.0,1.0)
+
m.addFacet(0.0,1.0,1.0, 0.0,0.0,1.0, 1.0,0.0,1.0)
m.addFacet(0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,1.0)
+
m.addFacet(0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,1.0,1.0, 1.0,0.0,1.0)
+
m.addFacet(1.0,1.0,0.0, 1.0,1.0,1.0, 1.0,0.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,0.0,1.0, 1.0,0.0,0.0)
+
m.addFacet(1.0,1.0,0.0, 1.0,0.0,1.0, 1.0,0.0,0.0)
# scale to a edge langth of 100
+
# scale to a edge langth of 100
m.scale(100.0)
+
m.scale(100.0)
# add the mesh to the active document
+
# add the mesh to the active document
me=doc.addObject("Mesh::Feature","Cube")
+
me=doc.addObject("Mesh::Feature","Cube")
me.Mesh=m
+
me.Mesh=m
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
=== Adding an arc or a circle === <!--T:13-->
 
=== Adding an arc or a circle === <!--T:13-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
import Part
+
import Part
doc = App.activeDocument()
+
doc = App.activeDocument()
c = Part.Circle()  
+
c = Part.Circle()  
c.Radius=10.0   
+
c.Radius=10.0   
f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature  
+
f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature  
f.Shape = c.toShape() # Assign the circle shape to the shape property  
+
f.Shape = c.toShape() # Assign the circle shape to the shape property  
doc.recompute()
+
doc.recompute()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 154: Line 154:
 
Each object in a FreeCAD document has an associated view representation object that stores all the parameters that define how the object appear, like color, linewidth, etc...
 
Each object in a FreeCAD document has an associated view representation object that stores all the parameters that define how the object appear, like color, linewidth, etc...
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
gad=Gui.activeDocument()  # access the active document containing all  
+
gad=Gui.activeDocument()  # access the active document containing all  
                          # view representations of the features in the
+
                          # view representations of the features in the
                          # corresponding App document  
+
                          # corresponding App document  
+
 
v=gad.getObject("Cube")    # access the view representation to the Mesh feature 'Cube'  
+
v=gad.getObject("Cube")    # access the view representation to the Mesh feature 'Cube'  
v.ShapeColor              # prints the color to the console  
+
v.ShapeColor              # prints the color to the console  
v.ShapeColor=(1.0,1.0,1.0) # sets the shape color to white
+
v.ShapeColor=(1.0,1.0,1.0) # sets the shape color to white
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 168: Line 168:
 
The Inventor framework allows to add one or more callback nodes to the scenegraph of the viewer. By default in FreeCAD one callback node is installed per viewer which allows to add global or static C++ functions. In the appropriate Python binding some methods are provided to make use of this technique from within Python code.
 
The Inventor framework allows to add one or more callback nodes to the scenegraph of the viewer. By default in FreeCAD one callback node is installed per viewer which allows to add global or static C++ functions. In the appropriate Python binding some methods are provided to make use of this technique from within Python code.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
App.newDocument()
+
App.newDocument()
v=Gui.activeDocument().activeView()
+
v=Gui.activeDocument().activeView()
 
   
 
   
#This class logs any mouse button events. As the registered callback function fires twice for 'down' and
+
#This class logs any mouse button events. As the registered callback function fires twice for 'down' and
#'up' events we need a boolean flag to handle this.
+
#'up' events we need a boolean flag to handle this.
class ViewObserver:
+
class ViewObserver:
    def logPosition(self, info):
+
  def logPosition(self, info):
        down = (info["State"] == "DOWN")
+
      down = (info["State"] == "DOWN")
        pos = info["Position"]
+
      pos = info["Position"]
        if (down):
+
      if (down):
            FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[1])+")\n")
+
          FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[1])+")\n")
 
        
 
        
o = ViewObserver()
+
o = ViewObserver()
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)
+
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:16-->
 
<!--T:16-->
 
Now, pick somewhere on the area in the 3D viewer and observe the messages in the output window. To finish the observation just call
 
Now, pick somewhere on the area in the 3D viewer and observe the messages in the output window. To finish the observation just call
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
v.removeEventCallback("SoMouseButtonEvent",c)
+
v.removeEventCallback("SoMouseButtonEvent",c)
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:17-->
 
<!--T:17-->
Line 232: Line 232:
 
It is also possible to get and change the scenegraph in Python, with the 'pivy' module -- a Python binding for Coin.
 
It is also possible to get and change the scenegraph in Python, with the 'pivy' module -- a Python binding for Coin.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
from pivy.coin import *                # load the pivy module
+
from pivy.coin import *                # load the pivy module
view = Gui.ActiveDocument.ActiveView  # get the active viewer
+
view = Gui.ActiveDocument.ActiveView  # get the active viewer
root = view.getSceneGraph()            # the root is an SoSeparator node
+
root = view.getSceneGraph()            # the root is an SoSeparator node
root.addChild(SoCube())
+
root.addChild(SoCube())
view.fitAll()
+
view.fitAll()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:20-->
 
<!--T:20-->
Line 244: Line 244:
 
However, it is possible to create a node by its internal name. An instance of the type 'SoFCSelection' can be created with
 
However, it is possible to create a node by its internal name. An instance of the type 'SoFCSelection' can be created with
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
type = SoType.fromName("SoFCSelection")
+
type = SoType.fromName("SoFCSelection")
node = type.createInstance()
+
node = type.createInstance()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 253: Line 253:
 
Adding new nodes to the scenegraph can be done this way. Take care of always adding a SoSeparator to contain the geometry, coordinates and material info of a same object. The following example adds a red line from (0,0,0) to (10,0,0):
 
Adding new nodes to the scenegraph can be done this way. Take care of always adding a SoSeparator to contain the geometry, coordinates and material info of a same object. The following example adds a red line from (0,0,0) to (10,0,0):
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
from pivy import coin
+
from pivy import coin
sg = Gui.ActiveDocument.ActiveView.getSceneGraph()
+
sg = Gui.ActiveDocument.ActiveView.getSceneGraph()
co = coin.SoCoordinate3()
+
co = coin.SoCoordinate3()
pts = [[0,0,0],[10,0,0]]
+
pts = [[0,0,0],[10,0,0]]
co.point.setValues(0,len(pts),pts)
+
co.point.setValues(0,len(pts),pts)
ma = coin.SoBaseColor()
+
ma = coin.SoBaseColor()
ma.rgb = (1,0,0)
+
ma.rgb = (1,0,0)
li = coin.SoLineSet()
+
li = coin.SoLineSet()
li.numVertices.setValue(2)
+
li.numVertices.setValue(2)
no = coin.SoSeparator()
+
no = coin.SoSeparator()
no.addChild(co)
+
no.addChild(co)
no.addChild(ma)
+
no.addChild(ma)
no.addChild(li)
+
no.addChild(li)
sg.addChild(no)
+
sg.addChild(no)
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:22-->
 
<!--T:22-->
 
To remove it, simply issue:
 
To remove it, simply issue:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
sg.removeChild(no)
+
sg.removeChild(no)
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 284: Line 284:
 
The python code produced by the Ui python compiler (the tool that converts qt-designer .ui files into python code) generally looks like this (it is simple, you can also code it directly in python):
 
The python code produced by the Ui python compiler (the tool that converts qt-designer .ui files into python code) generally looks like this (it is simple, you can also code it directly in python):
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
class myWidget_Ui(object):
+
class myWidget_Ui(object):
  def setupUi(self, myWidget):
+
def setupUi(self, myWidget):
    myWidget.setObjectName("my Nice New Widget")
+
  myWidget.setObjectName("my Nice New Widget")
    myWidget.resize(QtCore.QSize(QtCore.QRect(0,0,300,100).size()).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget
+
  myWidget.resize(QtCore.QSize(QtCore.QRect(0,0,300,100).size()).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget
 
   
 
   
    self.label = QtGui.QLabel(myWidget) # creates a label
+
  self.label = QtGui.QLabel(myWidget) # creates a label
    self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
+
  self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
    self.label.setObjectName("label") # sets its name, so it can be found by name
+
  self.label.setObjectName("label") # sets its name, so it can be found by name
   
+
 
  def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
+
  def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
    myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
+
  myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
    self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))
+
  self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:25-->
 
<!--T:25-->
 
Then, all you need to do is to create a reference to the FreeCAD Qt window, insert a custom widget into it, and "transform" this widget into yours with the Ui code we just made:
 
Then, all you need to do is to create a reference to the FreeCAD Qt window, insert a custom widget into it, and "transform" this widget into yours with the Ui code we just made:
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
  app = QtGui.qApp
+
app = QtGui.qApp
  FCmw = app.activeWindow() # the active qt window, = the freecad window since we are inside it
+
FCmw = app.activeWindow() # the active qt window, = the freecad window since we are inside it
  myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
+
myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
  myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
+
myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
  myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
+
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
  FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window
+
FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 315: Line 315:
 
The following code allows you to add a tab to the FreeCAD ComboView, besides the "Project" and "Tasks" tabs. It also uses the uic module to load an ui file directly in that tab.
 
The following code allows you to add a tab to the FreeCAD ComboView, besides the "Project" and "Tasks" tabs. It also uses the uic module to load an ui file directly in that tab.
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
 
 
# create new Tab in ComboView
 
# create new Tab in ComboView
 
from PySide import QtGui,QtCore
 
from PySide import QtGui,QtCore
Line 350: Line 349:
 
#tab.removeTab(2)
 
#tab.removeTab(2)
  
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
===Enable or disable a window=== <!--T:47-->
 
===Enable or disable a window=== <!--T:47-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
from PySide import QtGui
 
from PySide import QtGui
 
mw=FreeCADGui.getMainWindow()
 
mw=FreeCADGui.getMainWindow()
Line 376: Line 375:
 
va.setChecked(True)        # True or False
 
va.setChecked(True)        # True or False
 
dw.setVisible(True)        # True or False
 
dw.setVisible(True)        # True or False
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===Opening a custom webpage=== <!--T:27-->
 
===Opening a custom webpage=== <!--T:27-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
import WebGui
+
import WebGui
WebGui.openBrowser("http://www.example.com")
+
WebGui.openBrowser("http://www.example.com")
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===Getting the HTML contents of an opened webpage=== <!--T:28-->
 
===Getting the HTML contents of an opened webpage=== <!--T:28-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
from PyQt4 import QtGui,QtWebKit
+
from PyQt4 import QtGui,QtWebKit
a = QtGui.qApp
+
a = QtGui.qApp
mw = a.activeWindow()
+
mw = a.activeWindow()
v = mw.findChild(QtWebKit.QWebFrame)
+
v = mw.findChild(QtWebKit.QWebFrame)
html = unicode(v.toHtml())
+
html = unicode(v.toHtml())
print html
+
print html
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===Retrieve and use the coordinates of 3 selected points or objects=== <!--T:29-->
 
===Retrieve and use the coordinates of 3 selected points or objects=== <!--T:29-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
 
# the line above to put the accentuated in the remarks
 
# the line above to put the accentuated in the remarks
Line 425: Line 424:
  
 
   Console.PrintMessage(str(pt[1]) + "\r\n")
 
   Console.PrintMessage(str(pt[1]) + "\r\n")
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===List all objects=== <!--T:30-->
 
===List all objects=== <!--T:30-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
 
import FreeCAD,Draft
 
import FreeCAD,Draft
Line 449: Line 448:
  
 
#doc.removeObject("Box") # Clears the designated object
 
#doc.removeObject("Box") # Clears the designated object
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===Function resident with the mouse click action=== <!--T:31-->
 
===Function resident with the mouse click action=== <!--T:31-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
 
# causes an action to the mouse click on an object
 
# causes an action to the mouse click on an object
Line 477: Line 476:
 
FreeCADGui.Selection.addObserver(s)                      # install the function mode resident
 
FreeCADGui.Selection.addObserver(s)                      # install the function mode resident
 
#FreeCADGui.Selection.removeObserver(s)                  # Uninstall the resident function
 
#FreeCADGui.Selection.removeObserver(s)                  # Uninstall the resident function
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===List the components of an object=== <!--T:32-->
 
===List the components of an object=== <!--T:32-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
 
# This function list the components of an object
 
# This function list the components of an object
Line 578: Line 577:
  
 
detail()
 
detail()
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
 
===List the PropertiesList=== <!--T:33-->
 
===List the PropertiesList=== <!--T:33-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
import FreeCADGui
 
import FreeCADGui
 
from FreeCAD import Console
 
from FreeCAD import Console
Line 590: Line 589:
 
for p in op:
 
for p in op:
 
     Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")
 
     Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
===Search and data extraction=== <!--T:36-->
 
===Search and data extraction=== <!--T:36-->
Line 603: Line 602:
 
Displaying it in the "View Report" window (View > Views > View report)
 
Displaying it in the "View Report" window (View > Views > View report)
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
  
 
# -*- coding: utf-8 -*-
 
# -*- coding: utf-8 -*-
Line 787: Line 786:
 
Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
 
Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
 
App.Console.PrintMessage("Rot_3        : "+str(Rot_3)+"\n\n")
 
App.Console.PrintMessage("Rot_3        : "+str(Rot_3)+"\n\n")
##################################################################################</syntaxhighlight>
+
##################################################################################
 +
}}
  
 
Manual search of an element with label
 
Manual search of an element with label
  
<syntaxhighlight>
+
{{Code|code=
 
# Extract the coordinate X,Y,Z and Angle giving the label  
 
# Extract the coordinate X,Y,Z and Angle giving the label  
 
App.Console.PrintMessage("Base.x      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
 
App.Console.PrintMessage("Base.x      : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
Line 799: Line 799:
 
##################################################################################
 
##################################################################################
  
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
  
Line 821: Line 821:
 
Change the value of "numberOfPoints" if you want a different number of points (precision)
 
Change the value of "numberOfPoints" if you want a different number of points (precision)
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
numberOfPoints = 100                                                        # Decomposition number (or precision you can change)
 
numberOfPoints = 100                                                        # Decomposition number (or precision you can change)
 
selectedEdge = FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0].copy() # select one element
 
selectedEdge = FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0].copy() # select one element
Line 829: Line 829:
 
     i+=1
 
     i+=1
 
     print i, " X", p.x, " Y", p.y, " Z", p.z
 
     print i, " X", p.x, " Y", p.y, " Z", p.z
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
<!--T:45-->
 
<!--T:45-->
 
Other method display on "Int" and "Float"
 
Other method display on "Int" and "Float"
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
import Part
 
import Part
 
from FreeCAD import Base
 
from FreeCAD import Base
Line 888: Line 888:
 
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"
 
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"
  
</syntaxhighlight>
+
}}
 
<translate>
 
<translate>
 
===Select all objects in the document=== <!--T:46-->
 
===Select all objects in the document=== <!--T:46-->
 
</translate>
 
</translate>
<syntaxhighlight>
+
{{Code|code=
 
import FreeCAD
 
import FreeCAD
 
for obj in FreeCAD.ActiveDocument.Objects:
 
for obj in FreeCAD.ActiveDocument.Objects:
Line 899: Line 899:
 
     obj = App.ActiveDocument.getObject(objName)
 
     obj = App.ActiveDocument.getObject(objName)
 
     Gui.Selection.addSelection(obj)              # select the object
 
     Gui.Selection.addSelection(obj)              # select the object
</syntaxhighlight>
+
}}
  
 
<translate>
 
<translate>

Revision as of 20:11, 22 December 2014

This page contains examples, pieces, chunks of FreeCAD python code collected from users experiences and discussions on the forums. Read and use it as a start for your own scripts...


A typical InitGui.py file

Every module must contain, besides your main module file, an InitGui.py file, responsible for inserting the module in the main Gui. This is an example of a simple one.

class ScriptWorkbench (Workbench): 
    MenuText = "Scripts"
    def Initialize(self):
        import Scripts # assuming Scripts.py is your module
        list = ["Script_Cmd"] # That list must contain command names, that can be defined in Scripts.py
        self.appendToolbar("My Scripts",list) 
        
Gui.addWorkbench(ScriptWorkbench())

A typical module file

This is an example of a main module file, containing everything your module does. It is the Scripts.py file invoked by the previous example. You can have all your custom commands here.

import FreeCAD, FreeCADGui 
 
class ScriptCmd: 
   def Activated(self): 
       # Here your write what your ScriptCmd does...
       FreeCAD.Console.PrintMessage('Hello, World!')
   def GetResources(self): 
       return {'Pixmap' : 'path_to_an_icon/myicon.png', 'MenuText': 'Short text', 'ToolTip': 'More detailed text'} 
       
FreeCADGui.addCommand('Script_Cmd', ScriptCmd())

Import a new filetype

Making an importer for a new filetype in FreeCAD is easy. FreeCAD doesn't consider that you import data in an opened document, but rather that you simply can directly open the new filetype. So what you need to do is to add the new file extension to FreeCAD's list of known extensions, and write the code that will read the file and create the FreeCAD objects you want:

This line must be added to the InitGui.py file to add the new file extension to the list:

# Assumes Import_Ext.py is the file that has the code for opening and reading .ext files
FreeCAD.addImportType("Your new File Type (*.ext)","Import_Ext")

Then in the Import_Ext.py file:

def open(filename): 
   doc=App.newDocument()
   # here you do all what is needed with filename, read, classify data, create corresponding FreeCAD objects
   doc.recompute()

To export your document to some new filetype works the same way, except that you use:

FreeCAD.addExportType("Your new File Type (*.ext)","Export_Ext") 

Adding a line

A line simply has 2 points.

import Part,PartGui 
doc=App.activeDocument() 
# add a line element to the document and set its points 
l=Part.Line()
l.StartPoint=(0.0,0.0,0.0)
l.EndPoint=(1.0,1.0,1.0)
doc.addObject("Part::Feature","Line").Shape=l.toShape() 
doc.recompute()

Adding a polygon

A polygon is simply a set of connected line segments (a polyline in AutoCAD). It doesn't need to be closed.

import Part,PartGui 
doc=App.activeDocument()
n=list() 
# create a 3D vector, set its coordinates and add it to the list 
v=App.Vector(0,0,0) 
n.append(v) 
v=App.Vector(10,0,0) 
n.append(v) 
#... repeat for all nodes 
# Create a polygon object and set its nodes 
p=doc.addObject("Part::Polygon","Polygon") 
p.Nodes=n 
doc.recompute()

Adding and removing an object to a group

doc=App.activeDocument() 
grp=doc.addObject("App::DocumentObjectGroup", "Group") 
lin=doc.addObject("Part::Feature", "Line")
grp.addObject(lin) # adds the lin object to the group grp
grp.removeObject(lin) # removes the lin object from the group grp

Note: You can even add other groups to a group...

Adding a Mesh

import Mesh
doc=App.activeDocument()
# create a new empty mesh
m = Mesh.Mesh()
# build up box out of 12 facets
m.addFacet(0.0,0.0,0.0, 0.0,0.0,1.0, 0.0,1.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,1.0, 0.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,0.0, 1.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 1.0,0.0,1.0, 0.0,0.0,1.0)
m.addFacet(0.0,0.0,0.0, 0.0,1.0,0.0, 1.0,1.0,0.0)
m.addFacet(0.0,0.0,0.0, 1.0,1.0,0.0, 1.0,0.0,0.0)
m.addFacet(0.0,1.0,0.0, 0.0,1.0,1.0, 1.0,1.0,1.0)
m.addFacet(0.0,1.0,0.0, 1.0,1.0,1.0, 1.0,1.0,0.0)
m.addFacet(0.0,1.0,1.0, 0.0,0.0,1.0, 1.0,0.0,1.0)
m.addFacet(0.0,1.0,1.0, 1.0,0.0,1.0, 1.0,1.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,1.0,1.0, 1.0,0.0,1.0)
m.addFacet(1.0,1.0,0.0, 1.0,0.0,1.0, 1.0,0.0,0.0)
# scale to a edge langth of 100
m.scale(100.0)
# add the mesh to the active document
me=doc.addObject("Mesh::Feature","Cube")
me.Mesh=m

Adding an arc or a circle

import Part
doc = App.activeDocument()
c = Part.Circle() 
c.Radius=10.0  
f = doc.addObject("Part::Feature", "Circle") # create a document with a circle feature 
f.Shape = c.toShape() # Assign the circle shape to the shape property 
doc.recompute()

Accessing and changing representation of an object

Each object in a FreeCAD document has an associated view representation object that stores all the parameters that define how the object appear, like color, linewidth, etc...

gad=Gui.activeDocument()   # access the active document containing all 
                          # view representations of the features in the
                          # corresponding App document 

v=gad.getObject("Cube")    # access the view representation to the Mesh feature 'Cube' 
v.ShapeColor               # prints the color to the console 
v.ShapeColor=(1.0,1.0,1.0) # sets the shape color to white

Observing mouse events in the 3D viewer via Python

The Inventor framework allows to add one or more callback nodes to the scenegraph of the viewer. By default in FreeCAD one callback node is installed per viewer which allows to add global or static C++ functions. In the appropriate Python binding some methods are provided to make use of this technique from within Python code.

App.newDocument()
v=Gui.activeDocument().activeView()
 
#This class logs any mouse button events. As the registered callback function fires twice for 'down' and
#'up' events we need a boolean flag to handle this.
class ViewObserver:
   def logPosition(self, info):
       down = (info["State"] == "DOWN")
       pos = info["Position"]
       if (down):
           FreeCAD.Console.PrintMessage("Clicked on position: ("+str(pos[0])+", "+str(pos[1])+")\n")
       
o = ViewObserver()
c = v.addEventCallback("SoMouseButtonEvent",o.logPosition)

Now, pick somewhere on the area in the 3D viewer and observe the messages in the output window. To finish the observation just call

v.removeEventCallback("SoMouseButtonEvent",c)

The following event types are supported

  • SoEvent -- all kind of events
  • SoButtonEvent -- all mouse button and key events
  • SoLocation2Event -- 2D movement events (normally mouse movements)
  • SoMotion3Event -- 3D movement events (normally spaceball)
  • SoKeyboardEvent -- key down and up events
  • SoMouseButtonEvent -- mouse button down and up events
  • SoSpaceballButtonEvent -- spaceball button down and up events

The Python function that can be registered with addEventCallback() expects a dictionary. Depending on the watched event the dictionary can contain different keys.

For all events it has the keys:

  • Type -- the name of the event type i.e. SoMouseEvent, SoLocation2Event, ...
  • Time -- the current time as string
  • Position -- a tuple of two integers, mouse position
  • ShiftDown -- a boolean, true if Shift was pressed otherwise false
  • CtrlDown -- a boolean, true if Ctrl was pressed otherwise false
  • AltDown -- a boolean, true if Alt was pressed otherwise false

For all button events, i.e. keyboard, mouse or spaceball events

  • State -- A string 'UP' if the button was up, 'DOWN' if it was down or 'UNKNOWN' for all other cases

For keyboard events:

  • Key -- a character of the pressed key

For mouse button event

  • Button -- The pressed button, could be BUTTON1, ..., BUTTON5 or ANY

For spaceball events:

  • Button -- The pressed button, could be BUTTON1, ..., BUTTON7 or ANY

And finally motion events:

  • Translation -- a tuple of three floats
  • Rotation -- a quaternion for the rotation, i.e. a tuple of four floats

Manipulate the scenegraph in Python

It is also possible to get and change the scenegraph in Python, with the 'pivy' module -- a Python binding for Coin.

from pivy.coin import *                # load the pivy module
view = Gui.ActiveDocument.ActiveView   # get the active viewer
root = view.getSceneGraph()            # the root is an SoSeparator node
root.addChild(SoCube())
view.fitAll()

The Python API of pivy is created by using the tool SWIG. As we use in FreeCAD some self-written nodes you cannot create them directly in Python. However, it is possible to create a node by its internal name. An instance of the type 'SoFCSelection' can be created with

type = SoType.fromName("SoFCSelection")
node = type.createInstance()

Adding and removing objects to/from the scenegraph

Adding new nodes to the scenegraph can be done this way. Take care of always adding a SoSeparator to contain the geometry, coordinates and material info of a same object. The following example adds a red line from (0,0,0) to (10,0,0):

from pivy import coin
sg = Gui.ActiveDocument.ActiveView.getSceneGraph()
co = coin.SoCoordinate3()
pts = [[0,0,0],[10,0,0]]
co.point.setValues(0,len(pts),pts)
ma = coin.SoBaseColor()
ma.rgb = (1,0,0)
li = coin.SoLineSet()
li.numVertices.setValue(2)
no = coin.SoSeparator()
no.addChild(co)
no.addChild(ma)
no.addChild(li)
sg.addChild(no)

To remove it, simply issue:

sg.removeChild(no)

Adding custom widgets to the interface

You can create custom widgets with Qt designer, transform them into a python script, and then load them into the FreeCAD interface with PyQt4.

The python code produced by the Ui python compiler (the tool that converts qt-designer .ui files into python code) generally looks like this (it is simple, you can also code it directly in python):

class myWidget_Ui(object):
 def setupUi(self, myWidget):
   myWidget.setObjectName("my Nice New Widget")
   myWidget.resize(QtCore.QSize(QtCore.QRect(0,0,300,100).size()).expandedTo(myWidget.minimumSizeHint())) # sets size of the widget
 
   self.label = QtGui.QLabel(myWidget) # creates a label
   self.label.setGeometry(QtCore.QRect(50,50,200,24)) # sets its size
   self.label.setObjectName("label") # sets its name, so it can be found by name

 def retranslateUi(self, draftToolbar): # built-in QT function that manages translations of widgets
   myWidget.setWindowTitle(QtGui.QApplication.translate("myWidget", "My Widget", None, QtGui.QApplication.UnicodeUTF8))
   self.label.setText(QtGui.QApplication.translate("myWidget", "Welcome to my new widget!", None, QtGui.QApplication.UnicodeUTF8))

Then, all you need to do is to create a reference to the FreeCAD Qt window, insert a custom widget into it, and "transform" this widget into yours with the Ui code we just made:

app = QtGui.qApp
FCmw = app.activeWindow() # the active qt window, = the freecad window since we are inside it
myNewFreeCADWidget = QtGui.QDockWidget() # create a new dckwidget
myNewFreeCADWidget.ui = myWidget_Ui() # load the Ui script
myNewFreeCADWidget.ui.setupUi(myNewFreeCADWidget) # setup the ui
FCmw.addDockWidget(QtCore.Qt.RightDockWidgetArea,myNewFreeCADWidget) # add the widget to the main window

Adding a Tab to the Combo View

The following code allows you to add a tab to the FreeCAD ComboView, besides the "Project" and "Tasks" tabs. It also uses the uic module to load an ui file directly in that tab.

# create new Tab in ComboView
from PySide import QtGui,QtCore
#from PySide import uic

def getMainWindow():
   "returns the main window"
   # using QtGui.qApp.activeWindow() isn't very reliable because if another
   # widget than the mainwindow is active (e.g. a dialog) the wrong widget is
   # returned
   toplevel = QtGui.qApp.topLevelWidgets()
   for i in toplevel:
       if i.metaObject().className() == "Gui::MainWindow":
           return i
   raise Exception("No main window found")

def getComboView(mw):
   dw=mw.findChildren(QtGui.QDockWidget)
   for i in dw:
       if str(i.objectName()) == "Combo View":
           return i.findChild(QtGui.QTabWidget)
       elif str(i.objectName()) == "Python Console":
           return i.findChild(QtGui.QTabWidget)
   raise Exception ("No tab widget found")

mw = getMainWindow()
tab = getComboView(getMainWindow())
tab2=QtGui.QDialog()
tab.addTab(tab2,"A Special Tab")

#uic.loadUi("/myTaskPanelforTabs.ui",tab2)
tab2.show()
#tab.removeTab(2)

Enable or disable a window

from PySide import QtGui
mw=FreeCADGui.getMainWindow()
dws=mw.findChildren(QtGui.QDockWidget)

# objectName may be :
# "Report view"
# "Tree view"
# "Property view"
# "Selection view"
# "Combo View"
# "Python console"
# "draftToolbar"

for i in dws:
  if i.objectName() == "Report view":
    dw=i
    break

va=dw.toggleViewAction()
va.setChecked(True)        # True or False
dw.setVisible(True)        # True or False

Opening a custom webpage

import WebGui
WebGui.openBrowser("http://www.example.com")

Getting the HTML contents of an opened webpage

from PyQt4 import QtGui,QtWebKit
a = QtGui.qApp
mw = a.activeWindow()
v = mw.findChild(QtWebKit.QWebFrame)
html = unicode(v.toHtml())
print html

Retrieve and use the coordinates of 3 selected points or objects

# -*- coding: utf-8 -*-
# the line above to put the accentuated in the remarks
# If this line is missing, an error will be returned
# extract and use the coordinates of 3 objects selected
import Part, FreeCAD, math, PartGui, FreeCADGui
from FreeCAD import Base, Console
sel = FreeCADGui.Selection.getSelection() # " sel " contains the items selected
if len(sel)!=3 :
  # If there are no 3 objects selected, an error is displayed in the report view
  # The \r and \n at the end of line mean return and the newline CR + LF.
  Console.PrintError("Select 3 points exactly\r\n")
else :
  points=[]
  for obj in sel:
    points.append(obj.Shape.BoundBox.Center)

  for pt in points:
    # display of the coordinates in the report view
    Console.PrintMessage(str(pt.x)+"\r\n")
    Console.PrintMessage(str(pt.y)+"\r\n")
    Console.PrintMessage(str(pt.z)+"\r\n")

  Console.PrintMessage(str(pt[1]) + "\r\n")

List all objects

# -*- coding: utf-8 -*-
import FreeCAD,Draft
# List all objects of the document
doc = FreeCAD.ActiveDocument
objs = FreeCAD.ActiveDocument.Objects
#App.Console.PrintMessage(str(objs) + "\n")
#App.Console.PrintMessage(str(len(FreeCAD.ActiveDocument.Objects)) + " Objects"  + "\n")

for obj in objs:
    a = obj.Name                                             # list the Name  of the object  (not modifiable)
    b = obj.Label                                            # list the Label of the object  (modifiable)
    try:
        c = obj.LabelText                                    # list the LabeText of the text (modifiable)
        App.Console.PrintMessage(str(a) +" "+ str(b) +" "+ str(c) + "\n") # Displays the Name the Label and the text
    except:
        App.Console.PrintMessage(str(a) +" "+ str(b) + "\n") # Displays the Name and the Label of the object

#doc.removeObject("Box") # Clears the designated object

Function resident with the mouse click action

# -*- coding: utf-8 -*-
# causes an action to the mouse click on an object
# This function remains resident (in memory) with the function "addObserver(s)"
# "removeObserver(s) # Uninstalls the resident function
class SelObserver:
    def addSelection(self,doc,obj,sub,pnt):               # Selection
        App.Console.PrintMessage("addSelection"+ "\n")
        App.Console.PrintMessage(str(doc)+ "\n")          # Name of the document
        App.Console.PrintMessage(str(obj)+ "\n")          # Name of the object
        App.Console.PrintMessage(str(sub)+ "\n")          # The part of the object name
        App.Console.PrintMessage(str(pnt)+ "\n")          # Coordinates of the object
        App.Console.PrintMessage("______"+ "\n")

    def removeSelection(self,doc,obj,sub):                # Delete the selected object
        App.Console.PrintMessage("removeSelection"+ "\n")
    def setSelection(self,doc):                           # Selection in ComboView
        App.Console.PrintMessage("setSelection"+ "\n")
    def clearSelection(self,doc):                         # If click on the screen, clear the selection
        App.Console.PrintMessage("clearSelection"+ "\n")  # If click on another object, clear the previous object
s =SelObserver()
FreeCADGui.Selection.addObserver(s)                       # install the function mode resident
#FreeCADGui.Selection.removeObserver(s)                   # Uninstall the resident function

List the components of an object

# -*- coding: utf-8 -*-
# This function list the components of an object
# and extract this object its XYZ coordinates,
# its edges and their lengths center of mass and coordinates
# its faces and their center of mass
# its faces and their surfaces and coordinates
# 8/05/2014

import Draft,Part
def detail():
    sel = FreeCADGui.Selection.getSelection()   # Select an object
    if len(sel) != 0:                           # If there is a selection then
        Vertx=[]
        Edges=[]
        Faces=[]
        compt_V=0
        compt_E=0
        compt_F=0
        pas    =0
        perimetre = 0.0   
        EdgesLong = []

        # Displays the "Name" and the "Label" of the selection
        App.Console.PrintMessage("Selection > " + str(sel[0].Name) + "  " + str(sel[0].Label) +"\n"+"\n")

        for j in enumerate(sel[0].Shape.Edges):                                     # Search the "Edges" and their lengths
            compt_E+=1
            Edges.append("Edge%d" % (j[0]+1))
            EdgesLong.append(str(sel[0].Shape.Edges[compt_E-1].Length))
            perimetre += (sel[0].Shape.Edges[compt_E-1].Length)                     # calculates the perimeter

            # Displays the "Edge" and its length
            App.Console.PrintMessage("Edge"+str(compt_E)+" Length > "+str(sel[0].Shape.Edges[compt_E-1].Length)+"\n")

            # Displays the "Edge" and its center mass
            App.Console.PrintMessage("Edge"+str(compt_E)+" Center > "+str(sel[0].Shape.Edges[compt_E-1].CenterOfMass)+"\n")

            num = sel[0].Shape.Edges[compt_E-1].Vertexes[0]
            Vertx.append("X1: "+str(num.Point.x))
            Vertx.append("Y1: "+str(num.Point.y))
            Vertx.append("Z1: "+str(num.Point.z))
            # Displays the coordinates 1
            App.Console.PrintMessage("X1: "+str(num.Point[0])+" Y1: "+str(num.Point[1])+" Z1: "+str(num.Point[2])+"\n")

            try:
                num = sel[0].Shape.Edges[compt_E-1].Vertexes[1]
                Vertx.append("X2: "+str(num.Point.x))
                Vertx.append("Y2: "+str(num.Point.y))
                Vertx.append("Z2: "+str(num.Point.z))
            except:
                Vertx.append("-")
                Vertx.append("-")
                Vertx.append("-")
            # Displays the coordinates 2
            App.Console.PrintMessage("X2: "+str(num.Point[0])+" Y2: "+str(num.Point[1])+" Z2: "+str(num.Point[2])+"\n")

            App.Console.PrintMessage("\n")
        App.Console.PrintMessage("Perimeter of the form  : "+str(perimetre)+"\n") 

        App.Console.PrintMessage("\n")
        FacesSurf = []
        for j in enumerate(sel[0].Shape.Faces):                                      # Search the "Faces" and their surface
            compt_F+=1
            Faces.append("Face%d" % (j[0]+1))
            FacesSurf.append(str(sel[0].Shape.Faces[compt_F-1].Area))

            # Displays 'Face' and its surface
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Surface "+str(sel[0].Shape.Faces[compt_F-1].Area)+"\n")

            # Displays 'Face' and its CenterOfMass
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Center  "+str(sel[0].Shape.Faces[compt_F-1].CenterOfMass)+"\n")

            # Displays 'Face' and its Coordinates
            FacesCoor = []
            fco = 0
            for f0 in sel[0].Shape.Faces[compt_F-1].Vertexes:                        # Search the Vertexes of the face
                fco += 1
                FacesCoor.append("X"+str(fco)+": "+str(f0.Point.x))
                FacesCoor.append("Y"+str(fco)+": "+str(f0.Point.y))
                FacesCoor.append("Z"+str(fco)+": "+str(f0.Point.z))

            # Displays 'Face' and its Coordinates
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Coordinate"+str(FacesCoor)+"\n")

            # Displays 'Face' and its Volume
            App.Console.PrintMessage("Face"+str(compt_F)+" >  Volume  "+str(sel[0].Shape.Faces[compt_F-1].Volume)+"\n")
            App.Console.PrintMessage("\n")

        # Displays the total surface of the form
        App.Console.PrintMessage("Surface of the form    : "+str(sel[0].Shape.Area)+"\n")

        # Displays the total Volume of the form
        App.Console.PrintMessage("Volume  of the form    : "+str(sel[0].Shape.Volume)+"\n")

detail()

List the PropertiesList

import FreeCADGui
from FreeCAD import Console
o = App.ActiveDocument.ActiveObject
op = o.PropertiesList
for p in op:
    Console.PrintMessage("Property: "+ str(p)+ " Value: " + str(o.getPropertyByName(p))+"\r\n")

Search and data extraction

Examples of research and decoding information on an object.

Each section is independently and is separated by "############" can be copied directly into the Python console, or in a macro or use this macro. The description of the macro in the commentary.

Displaying it in the "View Report" window (View > Views > View report)

# -*- coding: utf-8 -*-
from __future__ import unicode_literals
 
# Exemples de recherche et de decodage d'informations sur un objet
# Chaque section peut etre copiee directement dans la console Python ou dans une macro ou utilisez la macro tel quel
# certaines commandes se repetent seul l'approche est differente
#
# Examples of research and decoding information on an object
# Each section can be copied directly into the Python console, or in a macro or uses this macro
# Certain commands as repeat alone approach is different
#
# rev:29/09/2014
 
from FreeCAD import Base
import DraftVecUtils, Draft, Part
 
mydoc = FreeCAD.activeDocument().Name                                     # Name of active Document
App.Console.PrintMessage("Active docu    : "+str(mydoc)+"\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
object_Label = sel[0].Label                                               # Label of the object (modifiable)
App.Console.PrintMessage("object_Label   : "+str(object_Label)+"\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")            # sel[0] first object selected
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
object_Name  = sel[0].Name                                                # Name of the object (not modifiable)
App.Console.PrintMessage("object_Name    : "+str(object_Name)+"\n\n")
##################################################################################
 
try:
    SubElement = FreeCADGui.Selection.getSelectionEx()                    # sub element name with getSelectionEx()
    element_ = SubElement[0].SubElementNames[0]                           # name of 1 element selected
    App.Console.PrintMessage("elementSelec   : "+str(element_)+"\n\n")            
except:
    App.Console.PrintMessage("Oups"+"\n\n")            
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
App.Console.PrintMessage("sel            : "+str(sel[0])+"\n\n")          # sel[0] first object selected
##################################################################################
 
SubElement = FreeCADGui.Selection.getSelectionEx()                        # sub element name with getSelectionEx()
App.Console.PrintMessage("SubElement     : "+str(SubElement[0])+"\n\n")     # name of sub element
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
i = 0
for j in enumerate(sel[0].Shape.Edges):                                   # list all Edges
    i += 1
    App.Console.PrintMessage("Edges n : "+str(i)+"\n")
    a = sel[0].Shape.Edges[j[0]].Vertexes[0]
    App.Console.PrintMessage("X1             : "+str(a.Point.x)+"\n")     # coordinate XYZ first point
    App.Console.PrintMessage("Y1             : "+str(a.Point.y)+"\n")
    App.Console.PrintMessage("Z1             : "+str(a.Point.z)+"\n")
    try:
        a = sel[0].Shape.Edges[j[0]].Vertexes[1]
        App.Console.PrintMessage("X2             : "+str(a.Point.x)+"\n") # coordinate XYZ second point
        App.Console.PrintMessage("Y2             : "+str(a.Point.y)+"\n")
        App.Console.PrintMessage("Z2             : "+str(a.Point.z)+"\n")
    except:
        App.Console.PrintMessage("Oups"+"\n")    
App.Console.PrintMessage("\n")    
##################################################################################
 
try:
    SubElement = FreeCADGui.Selection.getSelectionEx()                    # sub element name with getSelectionEx()
    subElementName = Gui.Selection.getSelectionEx()[0].SubElementNames[0] # sub element name with getSelectionEx()
    App.Console.PrintMessage("subElementName : "+str(subElementName)+"\n")

    subObjectX = Gui.Selection.getSelectionEx()[0].SubObjects[0].Point.x  # sub element coordinate X
    App.Console.PrintMessage("subObject_X    : "+str(subObjectX)+"\n")
    subObjectY = Gui.Selection.getSelectionEx()[0].SubObjects[0].Point.y  # sub element coordinate Y
    App.Console.PrintMessage("subObject_Y    : "+str(subObjectY)+"\n")
    subObjectZ = Gui.Selection.getSelectionEx()[0].SubObjects[0].Point.z  # sub element coordinate Z
    App.Console.PrintMessage("subObject_Z    : "+str(subObjectZ)+"\n")

    subObjectLength = Gui.Selection.getSelectionEx()[0].SubObjects[0].Length # sub element Length
    App.Console.PrintMessage("subObjectLength: "+str(subObjectLength)+"\n")

    surfaceFace = Gui.Selection.getSelectionEx()[0].SubObjects[0].Area    # Area of the 1 face
    App.Console.PrintMessage("surfaceFace    : "+str(surfaceFace)+"\n\n")
except:
    App.Console.PrintMessage("Oups"+"\n\n")            
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
surface = sel[0].Shape.Area                                               # Area object complete
App.Console.PrintMessage("surfaceObjet   : "+str(surface)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
CenterOfMass = sel[0].Shape.CenterOfMass                                  # Center of Mass of the object
App.Console.PrintMessage("CenterOfMass   : "+str(CenterOfMass)+"\n")
App.Console.PrintMessage("CenterOfMassX  : "+str(CenterOfMass[0])+"\n")   # coordinates [0]=X [1]=Y [2]=Z
App.Console.PrintMessage("CenterOfMassY  : "+str(CenterOfMass[1])+"\n")
App.Console.PrintMessage("CenterOfMassZ  : "+str(CenterOfMass[2])+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
for j in enumerate(sel[0].Shape.Faces):                                   # List alles faces of the object
    App.Console.PrintMessage("Face           : "+str("Face%d" % (j[0]+1))+"\n")
App.Console.PrintMessage("\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
volume_ = sel[0].Shape.Volume                                             # Volume of the object
App.Console.PrintMessage("volume_        : "+str(volume_)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
boundBox_= sel[0].Shape.BoundBox                                          # BoundBox of the object
App.Console.PrintMessage("boundBox_      : "+str(boundBox_)+"\n")
 
boundBoxLX = boundBox_.XLength                                            # Length x boundBox rectangle
boundBoxLY = boundBox_.YLength                                            # Length y boundBox rectangle
boundBoxLZ = boundBox_.ZLength                                            # Length z boundBox rectangle
App.Console.PrintMessage("boundBoxLX     : "+str(boundBoxLX)+"\n")
App.Console.PrintMessage("boundBoxLY     : "+str(boundBoxLY)+"\n")
App.Console.PrintMessage("boundBoxLZ     : "+str(boundBoxLZ)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement                                               # Placement Vector XYZ and Yaw-Pitch-Roll
App.Console.PrintMessage("Placement      : "+str(pl)+"\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Base                                          # Placement Vector XYZ
App.Console.PrintMessage("PlacementBase  : "+str(pl)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
Yaw = sel[0].Shape.Placement.Rotation.toEuler()[0]                        # decode angle Euler Yaw
App.Console.PrintMessage("Yaw            : "+str(Yaw)+"\n")
Pitch = sel[0].Shape.Placement.Rotation.toEuler()[1]                      # decode angle Euler Pitch
App.Console.PrintMessage("Pitch          : "+str(Pitch)+"\n")
Roll = sel[0].Shape.Placement.Rotation.toEuler()[2]                       # decode angle Euler Yaw
App.Console.PrintMessage("Yaw            : "+str(Roll)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
oripl_X = sel[0].Placement.Base[0]                                        # decode Placement X
oripl_Y = sel[0].Placement.Base[1]                                        # decode Placement Y
oripl_Z = sel[0].Placement.Base[2]                                        # decode Placement Z
 
App.Console.PrintMessage("oripl_X        : "+str(oripl_X)+"\n")
App.Console.PrintMessage("oripl_Y        : "+str(oripl_Y)+"\n")
App.Console.PrintMessage("oripl_Z        : "+str(oripl_Z)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
rotation = sel[0].Placement.Rotation                                      # decode Placement Rotation
App.Console.PrintMessage("rotation              : "+str(rotation)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Rotation                                      # decode Placement Rotation other method
App.Console.PrintMessage("Placement Rot         : "+str(pl)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
pl = sel[0].Shape.Placement.Rotation.Angle                                # decode Placement Rotation Angle
App.Console.PrintMessage("Placement Rot Angle   : "+str(pl)+"\n\n")
##################################################################################
 
sel = FreeCADGui.Selection.getSelection()                                 # select object with getSelection()
Rot_0 = sel[0].Placement.Rotation.Q[0]                                    # decode Placement Rotation 0
App.Console.PrintMessage("Rot_0         : "+str(Rot_0)+ " rad ,  "+str(180 * Rot_0 / 3.1416)+" deg "+"\n")
 
Rot_1 = sel[0].Placement.Rotation.Q[1]                                    # decode Placement Rotation 1
App.Console.PrintMessage("Rot_1         : "+str(Rot_1)+ " rad ,  "+str(180 * Rot_1 / 3.1416)+" deg "+"\n")
 
Rot_2 = sel[0].Placement.Rotation.Q[2]                                    # decode Placement Rotation 2
App.Console.PrintMessage("Rot_2         : "+str(Rot_2)+ " rad ,  "+str(180 * Rot_2 / 3.1416)+" deg "+"\n")
 
Rot_3 = sel[0].Placement.Rotation.Q[3]                                    # decode Placement Rotation 3
App.Console.PrintMessage("Rot_3         : "+str(Rot_3)+"\n\n")
##################################################################################

Manual search of an element with label

# Extract the coordinate X,Y,Z and Angle giving the label 
App.Console.PrintMessage("Base.x       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.x)+"\n")
App.Console.PrintMessage("Base.y       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.y)+"\n")
App.Console.PrintMessage("Base.z       : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Base.z)+"\n")
App.Console.PrintMessage("Base.Angle   : "+str(FreeCAD.ActiveDocument.getObjectsByLabel("Cylindre")[0].Placement.Rotation.Angle)+"\n\n")
##################################################################################

PS: Usually the angles are given in Radian to convert :

  1. angle in Degrees to Radians :
    • Angle in radian = pi * (angle in degree) / 180
    • Angle in radian = math.radians(angle in degree)
  2. angle in Radians to Degrees :
    • Angle in degree = 180 * (angle in radian) / pi
    • Angle in degree = math.degrees(angle in radian)

Cartesian coordinates

This code displays the Cartesian coordinates of the selected item.

Change the value of "numberOfPoints" if you want a different number of points (precision)

numberOfPoints = 100                                                         # Decomposition number (or precision you can change)
selectedEdge = FreeCADGui.Selection.getSelectionEx()[0].SubObjects[0].copy() # select one element
points  = selectedEdge.discretize(numberOfPoints)                            # discretize the element
i=0
for p in points:                                                             # list and display the coordinates
    i+=1
    print i, " X", p.x, " Y", p.y, " Z", p.z

Other method display on "Int" and "Float"

import Part
from FreeCAD import Base

c=Part.makeCylinder(2,10)        # create the circle
Part.show(c)                     # display the shape

# slice accepts two arguments:
#+ the normal of the cross section plane
#+ the distance from the origin to the cross section plane. Here you have to find a value so that the plane intersects your object
s=c.slice(Base.Vector(0,1,0),0)  # 

# here the result is a single wire
# depending on the source object this can be several wires
s=s[0]

# if you only need the vertexes of the shape you can use
v=[]
for i in s.Vertexes:
    v.append(i.Point)

# but you can also sub-sample the section to have a certain number of points (int) ...
p1=s.discretize(20)
ii=0
for i in p1:
    ii+=1
    print i                                              # Vector()
    print ii, ": X:", i.x, " Y:", i.y, " Z:", i.z        # Vector decode
Draft.makeWire(p1,closed=False,face=False,support=None)  # to see the difference accuracy (20)

## uncomment to use
#import Draft
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # first transform the DWire in Wire         "downgrade"
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # second split the Wire in single objects   "downgrade"
#
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"


# ... or define a sampling distance (float)
p2=s.discretize(0.5)
ii=0
for i in p2:
    ii+=1
    print i                                              # Vector()
    print ii, ": X:", i.x, " Y:", i.y, " Z:", i.z        # Vector decode 
Draft.makeWire(p2,closed=False,face=False,support=None)  # to see the difference accuracy (0.5)

## uncomment to use
#import Draft
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # first transform the DWire in Wire         "downgrade"
#Draft.downgrade(App.ActiveDocument.ActiveObject,delete=True)  # second split the Wire in single objects   "downgrade"
#
##Draft.upgrade(FreeCADGui.Selection.getSelection(),delete=True) # to attach lines contiguous SELECTED use "upgrade"

Select all objects in the document

import FreeCAD
for obj in FreeCAD.ActiveDocument.Objects:
    print obj.Name                                # display the object Name
    objName = obj.Name
    obj = App.ActiveDocument.getObject(objName)
    Gui.Selection.addSelection(obj)               # select the object
Other languages:
čeština • ‎Deutsch • ‎English • ‎español • ‎français • ‎Bahasa Indonesia • ‎italiano • ‎日本語 • ‎polski • ‎română • ‎русский • ‎svenska • ‎Türkçe